<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:f="jakarta.faces.core"
	xmlns:h="jakarta.faces.html" xmlns:ui="jakarta.faces.facelets"
	xmlns:bw="http://www.scc.kit.edu/bwfacelets"
	xmlns:p="http://primefaces.org/ui"
	xmlns:of="http://omnifaces.org/functions">

<h:head>
	<title></title>

</h:head>

<body>

	<f:view>
		<f:metadata>
		   <f:viewParam name="t" value="#{emailAddressesBean.token}"/>
			<f:event type="jakarta.faces.event.PreRenderViewEvent"
				listener="#{emailAddressesBean.preRenderView}" />
		</f:metadata>

		<ui:composition template="/template/default.xhtml">
			<ui:param name="title" value="#{messages.title}" />


			<ui:define name="content">
				<h:form id="form" prependId="false" class="full">

					<h3>
						<h:outputText value="#{messages['email_addresses.heading']}" />
					</h3>
					<div>
						<h:outputText value="#{messages['email_addresses.intro']}" />
					</div>
					<div class="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">
						<p:messages showDetail="true" />
					</div>


					<div class="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">

						<h:panelGroup
							rendered="#{not empty emailAddressesBean.identity.primaryEmail.emailAddress}">
							<p:selectOneListbox id="userSelect" var="e"
								value="#{emailAddressesBean.chosenPrimary}"
								converter="#{identityEmailAddressConverter}"
								style="font-size: 1em;">
								<f:selectItems value="#{emailAddressesBean.primaryEmailList}"
									var="email" itemLabel="#{email.emailAddress}"
									itemValue="#{email}" />


								<p:column
									rendered="#{emailAddressesBean.chosenPrimary != null and e.emailAddress == emailAddressesBean.chosenPrimary.emailAddress}">

									<div style="float: left;">
										<b><h:outputText value="#{e.emailAddress}" /> <h:outputText
												value="&nbsp;#{messages.preferred_option}" /> </b>

									</div>

									<div style="float: right;">
										<h:panelGroup
											rendered="#{e.emailStatus == 'FROM_ATTRIBUTE_VERIFIED' or e.emailStatus == 'FROM_ATTRIBUTE_UNVERIFIED'}">

											<p:commandLink
												title="#{messages['tooltip.email_non_removable']}">
												<i class="pi pi-ban"
													style="color: #00876c; font-size: 1.5rem"></i>
												<p:tooltip
													value="#{messages['tooltip.email_non_removable']}"
													showEffect="clip" hideEffect="fold" position="bottom" />
											</p:commandLink>

										</h:panelGroup>
									</div>

								</p:column>


								<p:column
									rendered="#{emailAddressesBean.chosenPrimary != null and e.emailAddress != emailAddressesBean.chosenPrimary.emailAddress}">
									<div style="float: left;">
										<h:outputText value="#{e.emailAddress}" />
									</div>

									<div style="float: right;">

										<p:commandLink title="#{messages['tooltip.email_as_primary']}"
											action="#{emailAddressesBean.setPrimaryEmailAddress()}"
											ajax="true" update="form"
											oncomplete="setTimeout(function(){window.location.reload();}, 2000);">
											<p:commandButton id="setPrimaryA" icon="fa fa-star"
												style="width: 35px; height: 35px;" />

											<p:tooltip value="#{messages['tooltip.email_as_primary']}"
												showEffect="clip" hideEffect="fold" position="bottom" />

										</p:commandLink>

										<h:panelGroup
											rendered="#{e.emailStatus != 'FROM_ATTRIBUTE_VERIFIED' and e.emailStatus != 'FROM_ATTRIBUTE_UNVERIFIED'}">

											<h:outputText value="&nbsp;" />

											<p:commandLink title="#{messages['tooltip.email_delete']}">

												<p:commandButton icon="fa fa-trash"
													style="width: 35px; height: 35px;"
													onclick="PF('confirmDelete').show()" />

												<p:tooltip value="#{messages['tooltip.email_delete']}"
													showEffect="clip" hideEffect="fold" position="bottom" />
											</p:commandLink>
										</h:panelGroup>

										<h:panelGroup
											rendered="#{e.emailStatus == 'FROM_ATTRIBUTE_VERIFIED' or e.emailStatus == 'FROM_ATTRIBUTE_UNVERIFIED'}">

											<h:outputText value="&nbsp;&nbsp;" />

											<p:commandLink
												title="#{messages['tooltip.email_non_removable']}">
												<i class="pi pi-ban"
													style="color: #00876c; font-size: 1.5rem"></i>
												<p:tooltip
													value="#{messages['tooltip.email_non_removable']}"
													showEffect="clip" hideEffect="fold" position="bottom" />
											</p:commandLink>

										</h:panelGroup>
									</div>

								</p:column>

							</p:selectOneListbox>

							<!-- Confirmation Dialog -->
							<p:confirmDialog message="#{messages['confirm_msg']}"
								widgetVar="confirmDelete" class="form">
								<p:commandButton value="#{messages['yes']}"
									actionListener="#{emailAddressesBean.deleteEmailAddress(emailAddressesBean.chosenPrimary)}"
									update="userSelect" oncomplete="PF('confirmDelete').hide()" />
								<p:commandButton value="#{messages['no']}"
									onclick="PF('confirmDelete').hide();" type="button" />
							</p:confirmDialog>
						</h:panelGroup>
					</div>

					<ui:repeat widgetVar="verifyTk" id="verifyTkId" var="email"
						value="#{emailAddressesBean.identity.emailAddresses}">
						<h:panelGroup layout="block"
							style="margin: 1px; padding: 10px; background-color: #f8f9fa; border: 1px solid #dee2e6;"
							class="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9"
							rendered="#{email.emailStatus == 'UNVERIFIED'}">
							<h:panelGroup>
								<div>
									<b><h:outputText value="#{email.emailAddress}&nbsp;" /></b>
									<h:outputText value="#{messages['email_addresses.unverified']}" />
								</div>

								<div style="font-size: 1.05rem;">
									<h:outputText
										value="#{messages['email_addresses.token_sent']} " />
									<h:outputText
										value="#{of:formatDate(email.verificationSent, 'HH:mm dd.MM.yyyy')}, " />

									<h:outputText
										value="#{messages['email_addresses.token_valid_until']}" />
									#{of:formatDate(email.tokenValidUntil, 'HH:mm dd.MM.yyyy')}
								</div>

								<br></br>

								<div>

									<h:outputText
										value="#{messages['email_addresses.verification_token']}" />

									<p:inputText value="#{emailAddressesBean.token}"
										rendered="#{not empty emailAddressesBean.identity.primaryEmail.emailAddress}"
										required="false"
										onkeydown="if(event.key === 'Enter'){event.preventDefault();}" />

									<p:inputText value="#{emailAddressesBean.token}"
										rendered="#{empty emailAddressesBean.identity.primaryEmail.emailAddress}"
										required="false"
										onkeydown="if(event.key === 'Enter'){event.preventDefault();}" />

									<!-- 
									onkeydown="if(event.key === 'Enter'){event.preventDefault(); document.getElementById('verifyAndSet').click();}" 
									onkeydown="if(event.key === 'Enter'){event.preventDefault(); document.getElementById('verify').click();}" 
									-->

								</div>

								<div id="myButtons" class="form">

									<p:commandButton id="verify"
										rendered="#{not empty emailAddressesBean.identity.primaryEmail.emailAddress}"
										action="#{emailAddressesBean.checkVerification()}"
										icon="fa fa-check" ajax="true" update="form"
										style="width: 35px; height: 35px;"
										oncomplete="setTimeout(function(){window.location.reload();}, 2000);" />
									<p:tooltip for="verify"
										value="#{messages['tooltip.email_verify']}" showEffect="clip"
										position="bottom" hideEffect="fold" />


									<p:commandButton id="verifyAndSet"
										rendered="#{empty emailAddressesBean.identity.primaryEmail.emailAddress}"
										action="#{emailAddressesBean.checkVerificationAndSetAsPrimary()}"
										icon="fa fa-check" ajax="true" update="form"
										style="width: 35px; height: 35px;"
										oncomplete="setTimeout(function(){window.location.reload();}, 2000);" />
									<p:tooltip for="verifyAndSet"
										value="#{messages['tooltip.email_verify_set']}"
										position="bottom" showEffect="clip" hideEffect="fold" />


									<p:commandButton id="delete"
										action="#{emailAddressesBean.deleteEmailAddress(email)}"
										icon="fa fa-trash" ajax="true" update="form"
										style="width: 35px; height: 35px;"
										oncomplete="setTimeout(function(){window.location.reload();}, 2000);" />
									<p:tooltip for="delete"
										value="#{messages['tooltip.email_delete']}" showEffect="clip"
										position="bottom" hideEffect="fold" />


									<p:commandButton id="resend"
										action="#{emailAddressesBean.resendVerificationToken(email)}"
										icon="fa fa-sync" ajax="true" update="form"
										style="width: 35px; height: 35px;"
										oncomplete="setTimeout(function(){window.location.reload();}, 2000);" />
									<p:tooltip for="resend"
										value="#{messages['tooltip.email_resend']}" showEffect="clip"
										position="bottom" hideEffect="fold" />
								</div>


							</h:panelGroup>
						</h:panelGroup>
					</ui:repeat>

					<br></br>

					<div class="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">
						<h:panelGroup id="f2"
							rendered="#{empty emailAddressesBean.identity.primaryEmail.emailAddress}">
							<h:outputText value="#{messages['email_addresses.set_email']}: " />
							<p:inputText type="email"
								value="#{emailAddressesBean.inputEmailAddress}"
								onkeydown="if(event.key === 'Enter'){event.preventDefault(); document.getElementById('setId').click();}">
							</p:inputText>

							<div class="form">
								<p:commandButton id="setId"
									action="#{emailAddressesBean.setAnEmailAddress()}"
									value="#{messages['email_addresses.set']}"
									validateClient="true" ajax="true" update="form"
									oncomplete="setTimeout(function(){window.location.reload();}, 2000);" />
								<p:tooltip for="setId" value="#{messages['tooltip.email_set']}"
									showEffect="clip" hideEffect="fold" position="bottom" />

							</div>

						</h:panelGroup>
					</div>


					<div class="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">
						<h:panelGroup id="f1"
							rendered="#{not empty emailAddressesBean.identity.primaryEmail.emailAddress}">
							<h:outputText
								value="#{messages['email_addresses.add_email_address']}: " />
							<p:inputText type="email"
								value="#{emailAddressesBean.addEmailAddress}"
								onkeydown="if(event.key === 'Enter'){event.preventDefault(); document.getElementById('addId').click();}" />

							<div class="form">
								<p:commandButton id="addId"
									action="#{emailAddressesBean.addEmailAddress()}"
									value="#{messages['add']}" validateClient="true" ajax="true"
									update="form"
									oncomplete="setTimeout(function(){window.location.reload();}, 2000);" />
								<p:tooltip for="addId" value="#{messages['tooltip.email_add']}"
									showEffect="clip" hideEffect="fold" position="bottom" />

							</div>

						</h:panelGroup>
					</div>

					<br></br>

					<h:panelGrid columns="2"
						class="col-12 md:col-3 xl:col-3, col-12 md:col-9 xl:col-9">

						<h:panelGroup
							rendered="#{emailAddressesBean.isBackButtonVisable()}">
							<a href="../index.xhtml"
								style="font-size: 20px; font-weight: bold;"> <h:outputText
									value="#{messages.back}" />
							</a>
						</h:panelGroup>
						<h:panelGroup
							rendered="#{emailAddressesBean.isContinueButtonVisable()}">
							<p:commandButton action="#{emailAddressesBean.redirectToOriginalPage()}" value="#{messages['continue']}"/>
						</h:panelGroup>

					</h:panelGrid>
				</h:form>

			</ui:define>
		</ui:composition>
	</f:view>
</body>
</html>
